//-----------------------------------------------------------------------------
/*
    CEdit.h - Author: Marcus Krner - 2003 - This source is GPL
*/
#include "CEdit.h"

//-----------------------------------------------------------------------------
CEdit::CEdit()
{
}

//-----------------------------------------------------------------------------
CEdit::~CEdit()
{
    SDL_FreeSurface( m_pCollision );
}

//-----------------------------------------------------------------------------
void CEdit::init( int *prototypeNumber, CEntity** prototype, int *entities, CEntity **mapEntity, CEntity *entitylist, CIsoEngine *engine, CSDL *sdlFrame, CSimpleFont* font )
{
    m_pEngine = engine;
    m_pSDLFrame = sdlFrame;
    m_pFont = font;
    m_pMapEntity = mapEntity;
    m_pEntitylist = entitylist;
    m_pPrototype = prototype;
    m_pEntities = entities;
    m_pPrototypeNumber = prototypeNumber;
    m_iActGroup = 0;
    m_iActTile = 0;
    m_iTileLayer = 0;
    m_bTileEdit = true;
    m_bObjectEdit = m_bCollisionEdit = false;
    m_pCollision = sdlFrame->loadImage( "gfx/editor/collision.png" );
}

//-----------------------------------------------------------------------------
/*
    set a tile on map
*/
void CEdit::setTile( int layer, int group, int tile )
{
    int iMouseX = m_pSDLFrame->getMouseX();
    int iMouseY = m_pSDLFrame->getMouseY();

    int XPos = int( 0.5 * ( ( iMouseX - m_pEngine->getHalfMapWidth() + m_pEngine->getOffsetX() ) / ( m_pEngine->getTileWidth() / 2 ) ) + ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileWidth() / 2 ) ) );
    if( XPos >= 0 && XPos < m_pEngine->getMapWidth() )
    {
        int YPos = int( ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileHeight() / 2 ) ) - XPos );

        if( YPos >= 0 && YPos < m_pEngine->getMapHeight() )
        {
            switch( layer )
            {
                case 0:
                    m_pEngine->getMap()[ XPos + YPos * m_pEngine-> getMapWidth() ].m_iGroundGroup = group;
                    m_pEngine->getMap()[ XPos + YPos * m_pEngine-> getMapWidth() ].m_iGroundTile = tile;
                    break;
                    
                case 1:
                    m_pEngine->getMap()[ XPos + YPos * m_pEngine-> getMapWidth() ].m_iDetailGroup = group;
                    m_pEngine->getMap()[ XPos + YPos * m_pEngine-> getMapWidth() ].m_iDetailTile =tile;
                    break;
            }
        }
    }
}

//-----------------------------------------------------------------------------
/*
    set an entity on the entitymap
*/
void CEdit::setEntity( CEntity *entity )
{
     // get mousecoords
    int iMouseX = m_pSDLFrame->getMouseX();
    int iMouseY = m_pSDLFrame->getMouseY();

    int XPos = int( 0.5 * ( ( iMouseX - m_pEngine->getHalfMapWidth() + m_pEngine->getOffsetX() ) / ( m_pEngine->getTileWidth() / 2 ) ) + ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileWidth() / 2 ) ) );
    if( XPos >= 0 && XPos < m_pEngine->getMapWidth() )
    {
        int YPos = int( ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileHeight() / 2 ) ) - XPos );

        if( YPos >= 0 && YPos < m_pEngine->getMapHeight() )
        {

            // if the entity has a bigger tilesize than 1 set it on the other mapEntity tiles, too.
            // add entity to list

            // NOTE_ CODE HAVE TO BE REDONE
            
            // if entity is not NULL
            if( m_pMapEntity[ XPos + YPos * m_pEngine->getMapWidth() ] != NULL )
            {
              deleteEntityFromList( m_pMapEntity[ XPos + YPos * m_pEngine->getMapWidth() ] );
              m_pMapEntity[  XPos + YPos * m_pEngine->getMapWidth() ] = entity;
            }
            else
              m_pMapEntity[  XPos + YPos * m_pEngine->getMapWidth() ] = entity;            
            // and finally at the entity to our list
            addEntity( entity );
         }
    }
}

//-----------------------------------------------------------------------------
/*
    delete an entity on the entitymap
*/
void CEdit::deleteEntity()
{
     // get mousecoords
    int iMouseX = m_pSDLFrame->getMouseX();
    int iMouseY = m_pSDLFrame->getMouseY();

    int XPos = int( 0.5 * ( ( iMouseX - m_pEngine->getHalfMapWidth() + m_pEngine->getOffsetX() ) / ( m_pEngine->getTileWidth() / 2 ) ) + ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileWidth() / 2 ) ) );
    if( XPos >= 0 && XPos < m_pEngine->getMapWidth() )
    {
        int YPos = int( ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileHeight() / 2 ) ) - XPos );

        if( YPos >= 0 && YPos < m_pEngine->getMapHeight() )
        {
          if( m_pMapEntity[ ( XPos ) + ( YPos ) * m_pEngine->getMapWidth() ] != NULL )
          {
            // remove that entitiy
            cout << "blafasel2\n";
            deleteEntityFromList( m_pMapEntity[ XPos + YPos * m_pEngine->getMapWidth() ] );
            m_pMapEntity[ XPos + YPos * m_pEngine->getMapWidth() ] = NULL;
          }
        }
    }
}

//-----------------------------------------------------------------------------
/*
    delete an entity from the list
*/
void CEdit::deleteEntityFromList( CEntity *entity )
{
cout << entity << "\n";            
    if( entity != NULL)
    {
        // if entity is last in list
        if( entity->m_pNext == NULL )
        {

            entity->m_pPrev->m_pNext = NULL;
            cout << "test1\n";
            delete entity;
            cout << "test2\n";
        }
        else
        {
            entity->m_pNext->m_pPrev = entity->m_pPrev;
            entity->m_pPrev->m_pNext = entity->m_pNext;      
            cout << "test3\n";
            delete entity;
            cout << "test4\n";
        }
        --(*m_pEntities);
    }
}

void CEdit::idle()
{
    if( m_pSDLFrame->getMouseState() == SDL_BUTTON_LEFT )
    {
        if( m_bTileEdit )
            setTile( m_iTileLayer, m_iActGroup, m_iActTile );
        else if( m_bObjectEdit)
        {
            CEntity *tmp = m_pPrototype[ m_iActTile ]->clone();
            tmp->m_pPrev = tmp->m_pNext = NULL;
            setEntity( tmp );
        }
        else if( m_bCollisionEdit )
            setCollision( 1 );
    }
     if( m_pSDLFrame->getMouseState() == SDL_BUTTON_RIGHT )
    {
        if( m_bCollisionEdit )
          setCollision( 0 );
        else if( m_bObjectEdit)
          deleteEntity();
    }

    // switch to tilelayer 0 and tileedit
    if( m_pSDLFrame->keyPressed( SDLK_1 ) )
    {
        m_bTileEdit = true;
        m_iTileLayer = 0;
        m_iActTile = m_iActGroup = 0;
        m_bObjectEdit = false;
        m_bCollisionEdit = false;
    }
    // switch to tilelayer 1 and tileedit
    if( m_pSDLFrame->keyPressed( SDLK_2 ) )
    {
        m_bTileEdit = true;
        m_iTileLayer = 1;
        m_iActTile = m_iActGroup = 0;
        m_bObjectEdit = false;
        m_bCollisionEdit = false;
    }
    // switch to objectedit
    if( m_pSDLFrame->keyPressed( SDLK_3 ) )
    {
        m_bTileEdit = false;
        m_iTileLayer = 0;
        m_iActTile = m_iActGroup = 0;
        m_bObjectEdit = true;
        m_bCollisionEdit = false;
    }
    // activate collisionedit
    if( m_pSDLFrame->keyPressed( SDLK_4 ) )
    {
        m_bTileEdit = false;
        m_iTileLayer = 0;
        m_iActTile = m_iActGroup = 0;
        m_bObjectEdit = false;
        m_bCollisionEdit = true;
    }

    // save map
    if( m_pSDLFrame->keyPressed( SDLK_s ) )
    {
        saveMap( "maps/test.map" );
    }
    // decrease act tile
    if( m_pSDLFrame->keyPressed( SDLK_LEFT ) )
    {
        if( m_iActTile > 0 )
            --m_iActTile;
    }
    // increase act tile
    if( m_pSDLFrame->keyPressed( SDLK_RIGHT ) )
    {
        if( m_bTileEdit )
        {
            if( m_iTileLayer == 0 )
            {
                if( m_iActTile < m_pEngine->getGround()[ m_iActGroup ].getNumber() - 1 )
                    ++m_iActTile;
            }
            else if( m_iTileLayer == 1 )
            {
                if( m_iActTile < m_pEngine->getDetail()[ m_iActGroup ].getNumber() - 1 )
                    ++m_iActTile;
            }
        }
        else if( m_bObjectEdit )
        {
            if( m_iActTile < (*m_pPrototypeNumber) - 1 )
                ++m_iActTile;
        }
    }
    // increase group
    if( m_pSDLFrame->keyPressed( SDLK_UP ) )
    {
        if( m_iTileLayer == 0  )
        {
            if( m_iActGroup < m_pEngine->getNumberGround() - 1)
            {
                m_iActTile = 0;
                ++m_iActGroup;
            }
        }
        else if( m_iTileLayer == 1  )
        {
            if( m_iActGroup < m_pEngine->getNumberDetail() - 1)
            {
                m_iActTile = 0;
                ++m_iActGroup;
            }
        }
    }
    // decrease group
    if( m_pSDLFrame->keyPressed(SDLK_DOWN))
    {
        if( m_iTileLayer == 0  )
        {
            if( m_iActGroup > 0 )
            {
                m_iActTile = 0;
                --m_iActGroup;
            }
        }
        else if( m_iTileLayer == 1  )
        {
            if( m_iActGroup > 0 )
            {
                m_iActTile = 0;
                --m_iActGroup;
            }
        }
    }

    // draw editscreen
    draw();

   // show that we are in editmode
   m_pFont->putString( "[ editmode ]", 10, 40 );   
}

//-----------------------------------------------------------------------------
void CEdit::draw()
{
    // collisionedit
    if(m_bCollisionEdit )
    {
        for( int y = 0; y < m_pEngine->getMapHeight(); ++y)
            for( int x = 0; x < m_pEngine->getMapWidth(); ++x )
            {
                float fX = ( ( x - y ) * ( m_pEngine->getTileWidth()/ 2 ) ) + m_pEngine->getHalfMapWidth();
                float fY = ( ( x + y ) * ( m_pEngine->getTileHeight()/ 2 ) );
                SDL_Rect destRect =
                {
                    (int)( fX - m_pEngine->getOffsetX() ),
                    (int)( fY - m_pEngine->getOffsetY() ),
                    0,
                    0
                };
                SDL_Rect tileRect =
                {
                    0,
                    0,
                    m_pEngine->getTileWidth(),
                    m_pEngine->getTileHeight()
                };

                // test if the image we are going to draw is in our viewPort
                if( m_pEngine->clip( m_pEngine->getViewPort(), tileRect, destRect ) )
                // blit the collision tile
                if( m_pEngine->getMap()[ x + y * m_pEngine->getMapWidth() ].m_iCollision )
                    m_pSDLFrame->blitSurface( m_pCollision, tileRect, destRect );
            }
        m_pFont->putString( "( collisionedit )", 10,  m_pSDLFrame->getHeight() - 15 );
    }
    // tileedit ( ground and detail )
    else if( m_bTileEdit )
    {
        // set the source rect
        SDL_Rect srcRect;
        SDL_Rect dstRect;
        // layer 0
        if( m_iTileLayer == 0 )
        {
            srcRect.x = m_iActTile * m_pEngine->getGround()[ m_iActGroup ].getWidth();
            srcRect.y = 0;
            srcRect.w = m_pEngine->getGround()[ m_iActGroup ].getWidth();
            srcRect.h = m_pEngine->getGround()[ m_iActGroup ].getHeight();

            dstRect.x = m_pSDLFrame->getWidth() - srcRect.w - 20;
            dstRect.y = m_pSDLFrame->getHeight() - srcRect.h - 20;

            SDL_Rect screen = { dstRect.x - 10, dstRect.y - 10, srcRect.w + 20, srcRect.h + 20};
            SDL_FillRect( m_pSDLFrame->getVideomem(), &screen, 0x555588 );

            m_pSDLFrame->blitSurface( m_pEngine->getGround()[ m_iActGroup  ].getTiles(), srcRect, dstRect );
            
            // print out fps
            std::ostringstream o;
            o << "( tiledit [ groundlayer ] ) " << "( groupname : " << m_pEngine->getGround()[ m_iActGroup ].getName() << " ) ( act tile : " << m_iActTile << " )";
            m_pFont->putString( o.str().c_str(), 10,  m_pSDLFrame->getHeight() - 15 );
        }
        // layer 1
        else if( m_iTileLayer == 1 )
        {
            srcRect.x = m_iActTile * m_pEngine->getDetail()[ m_iActGroup ].getWidth();
            srcRect.y = 0;
            srcRect.w = m_pEngine->getDetail()[ m_iActGroup ].getWidth();
            srcRect.h = m_pEngine->getDetail()[ m_iActGroup ].getHeight();

            dstRect.x = m_pSDLFrame->getWidth() - srcRect.w - 20;
            dstRect.y = m_pSDLFrame->getHeight() - srcRect.h - 20;

            SDL_Rect screen = { dstRect.x - 10, dstRect.y - 10, srcRect.w + 20, srcRect.h + 20};
            SDL_FillRect( m_pSDLFrame->getVideomem(), &screen, 0x555588 );

            m_pSDLFrame->blitSurface( m_pEngine->getDetail()[ m_iActGroup ].getTiles(), srcRect, dstRect );
            // print out fps
            std::ostringstream o;
            o << "( tiledit [ detaillayer ] ) " << "( groupname : " << m_pEngine->getDetail()[ m_iActGroup ].getName() << " ) ( act tile : " << m_iActTile << " )";
            m_pFont->putString( o.str().c_str(), 10,  m_pSDLFrame->getHeight() - 15 );
        }
    }
    // objectedit
    else if( m_bObjectEdit )
    {
        //set the source rect
        SDL_Rect srcRect = { 0, 0, m_pPrototype[ m_iActTile ]->getSize().w, m_pPrototype[ m_iActTile ]->getSize().h };
       
        SDL_Rect dstRect;
        dstRect.x = m_pSDLFrame->getWidth() - srcRect.w - 20;
        dstRect.y = m_pSDLFrame->getHeight() - srcRect.h - 20;
                                
        SDL_Rect screen = { dstRect.x - 10, dstRect.y - 10, srcRect.w + 20, srcRect.h + 20};
        SDL_FillRect( m_pSDLFrame->getVideomem(), &screen, 0x555588 );

        m_pPrototype[ m_iActTile ]->draw( m_pSDLFrame, dstRect.x, dstRect.y );

        // print out fps
        std::ostringstream o;
         o << "objectedit . act prototype " << m_iActTile << " . prototype tilesize  " << m_pPrototype[  m_iActTile ]->getTileSize();
         m_pFont->putString( o.str().c_str(), 10,  m_pSDLFrame->getHeight() - 15 );
    }
}
    
//-----------------------------------------------------------------------------
void CEdit::saveMap( string file )
{
    for( int x = 0; x < m_pEngine->getMapWidth(); ++x )
        for( int y = 0; y < m_pEngine->getMapHeight(); ++y )
            if( m_pMapEntity[ x + y * m_pEngine->getMapWidth() ] == NULL )
                m_pEngine->getMap()[ x + y * m_pEngine->getMapWidth() ].m_iEntityID = 0;
            else           
                m_pEngine->getMap()[ x + y * m_pEngine->getMapWidth() ].m_iEntityID = m_pMapEntity[ x + y * m_pEngine->getMapWidth() ]->getID();
                

    m_pEngine->saveMap( "maps/test.map" );
}

//-----------------------------------------------------------------------------
/*
    add an entity to the list
*/
void CEdit::addEntity( CEntity *entity )
{
    CEntity *tmp = m_pEntitylist;

    while( tmp->m_pNext != NULL )
        tmp = tmp->m_pNext;
                
    tmp->m_pNext = entity;
    tmp->m_pNext->m_pPrev = tmp;
    ++(*m_pEntities);
}

//-----------------------------------------------------------------------------
void CEdit::setCollision( int i )
{
    int iMouseX = m_pSDLFrame->getMouseX();
    int iMouseY = m_pSDLFrame->getMouseY();

    int XPos = int( 0.5 * ( ( iMouseX - m_pEngine->getHalfMapWidth() + m_pEngine->getOffsetX() ) / ( m_pEngine->getTileWidth() / 2 ) ) + ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileWidth() / 2 ) ) );
    if( XPos >= 0 && XPos < m_pEngine->getMapWidth() )
    {
        int YPos = int( ( ( iMouseY + m_pEngine->getOffsetY() ) / ( m_pEngine->getTileHeight() / 2 ) ) - XPos );

        if( YPos >= 0 && YPos < m_pEngine->getMapHeight() )
            m_pEngine->getMap()[ XPos + YPos * m_pEngine-> getMapWidth() ].m_iCollision = i;
    }
}
