//-----------------------------------------------------------------------------
/*
    CEdit.h - Author: Marcus Krner - 2003 - This source is GPL
    editor class for herrschaft der tuerme
*/

#ifndef CEDIT_H_
#define CEDIT_H_

#include <iostream>
#include <string>
#include <sstream>

#include "CIsoEngine.h"
#include "CSDL.h"
#include "CSimpleFont.h"

// entities
#include "entities/CEntity.h"
#include "entities/CTower.h"
#include "entities/CEnvironment.h"

using namespace std;

class CEdit
{
public:
    CEdit();
    ~CEdit();
    void init( int *prototypeNumber, CEntity** prototype, int *entities, CEntity **mapEntity, CEntity *entitylist, CIsoEngine *engine, CSDL *sdlFrame, CSimpleFont* font );

    void setTile( int layer, int group, int tile );
    void setEntity( CEntity *entity );
    void addEntity( CEntity *entity );
    void deleteEntityFromList( CEntity *entity );
    void deleteEntity();
    void saveMap( string file );
    void setCollision( int i );
    void idle();
    void draw();
    
private:
    CIsoEngine* m_pEngine;
    CSDL* m_pSDLFrame;
    CSimpleFont* m_pFont;
    
    CEntity** m_pMapEntity;
    CEntity* m_pEntitylist;
    CEntity** m_pPrototype;                         // prototypes for entites

    SDL_Surface* m_pCollision;
    
    bool m_bObjectEdit, m_bTileEdit, m_bCollisionEdit;

    int* m_pPrototypeNumber;                      // existing prototypes overall
    int* m_pEntities;
    
    int m_iTileLayer;
    int m_iActGroup;
    int m_iActTile;
    int m_iActEntity;
};

#endif
