//-----------------------------------------------------------------------------
/*
    CGame.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/
#include "CGame.h"

//-----------------------------------------------------------------------------
CGame::CGame()
{
}

CGame::~CGame()
{
    delete m_pEdit;
    delete m_pEntitylist;
    delete m_pMenu;
    delete m_pFont;
    delete[] m_pPrototype;
    delete[] m_pMapEntity;
        delete char1;
                delete char2;
                        delete attack1;
                delete attack2;
    delete[] m_pMapChar;
    delete m_pCharlist;

//    delete m_pEffect1;
//    delete m_pEffect2;
    
}

//-----------------------------------------------------------------------------
/*
    init our CGame class
*/
void CGame::init( CSDL *sdlFrame, CIsoEngine *engine, CLog *log )
{
    m_pSDLFrame = sdlFrame;
    m_pEngine = engine;
    m_pLog = log;
    m_bEditMode = false;

    m_pFont = new CSimpleFont();
    m_pFont->init( "system/csdl_font2.png", m_pSDLFrame );
    
    m_iTILEHEIGHT = engine->getTileHeight();
    m_iTILEWIDTH = engine->getTileWidth();
    
    // set the dwFrameStart variable to the current ticks, used for calculating the deltaTime / loop
    m_dwFrameStart = SDL_GetTicks();
    m_dwFrameTime = 0;

    // load m_pPrototypes
    loadPrototypes( "system/prototypes.cfg" );

    // create m_pEntitylist
    m_pCharlist = new Char();
    
    // create m_pEntitylist
    m_pEntitylist = new CEntity();

    // set iEntities to 0
    m_iActEntities = 0;

    // set iEntities to 0
    m_iActChars = 0;
                                          
    // create map with size as big as the ground map for the entities
    m_pMapEntity = new CEntity*[ m_pEngine->getMapWidth() * m_pEngine->getMapHeight() ];
    m_pMapChar = new Char*[ m_pEngine->getMapWidth() * m_pEngine->getMapHeight() ];
    for( int x = 0; x < m_pEngine->getMapWidth(); ++x )
        for( int y = 0; y < m_pEngine->getMapHeight(); ++y )
        {
            // set the entities and chars to NULL
           m_pMapEntity[ x + y * m_pEngine->getMapWidth() ] = NULL;
           m_pMapChar[ x + y * m_pEngine->getMapWidth() ] = NULL;
        }
            
    // create the editor instance
    m_pEdit = new CEdit();
    m_pEdit->init(  &m_iPrototypeNumber, m_pPrototype, &m_iActEntities, m_pMapEntity, m_pEntitylist, m_pEngine, m_pSDLFrame, m_pFont );
    
    for( int y = 0; y < engine->getMapWidth(); ++y )
        for( int x = 0; x < engine->getMapHeight(); ++x )
        {
            if( m_pEngine->getMap()[ x + y * m_pEngine->getMapWidth() ].m_iEntityID > 0 )
            {
                CEntity *tmp = m_pPrototype[ m_pEngine->getMap()[ x + y * m_pEngine->getMapWidth() ].m_iEntityID - 1 ]->clone();
                for( int x2 = 0; x2 < tmp->getTileSize(); ++x2 )
                    for( int y2 = 0; y2 < tmp->getTileSize(); ++y2 )
                        m_pMapEntity[  ( x + x2 ) + ( y + y2 ) * m_pEngine->getMapWidth() ] = tmp; 
                addEntity( tmp );
            }
        }

    m_pMenu = new Menu( m_pFont );
    m_pMenu->loadMenu( "system/defaultmenu.cfg", m_pSDLFrame );
        
 // m_pEffect1 = new ParticleEffect( 0xfff888, 100.0f, 300.0f, 0.0f, 0.0f, -90.0f, 10.0f, 15, 300, 3000);
 //  m_pEffect2 = new ImageParticleEffect( m_pSDLFrame->loadImage( "gfx/particles/water.png"), 500.0f, 300.0f, 0.0f, 30.0f, 0.0f, 0.0f, 20, 100, 1500 );

 //TEMPORARY!!!!!

 attack1 = new Attack( m_pSDLFrame->loadImage( "gfx/attack/fire.png" ) );
  attack2 = new Attack( m_pSDLFrame->loadImage( "gfx/attack/blank.png" ) );
 
  char1 = new SimpleChar( m_pSDLFrame, "gfx/chars/quad/quad.png", 60, 70, 200.0f, 200.0f, 20.0f, 0.004f  );
  char1->setSelected( true );
  char1->setName( "Atlantis" );
  char1->addAttack( attack1 );
  //char1->addAttack( attack2 );
  
  char2 = new SimpleChar( m_pSDLFrame, "gfx/chars/quad/quad.png", 60, 70, 200.0f, 200.0f, 20.0f, 0.004f  );
  char2->setName( "Blurfasel" );
  char2->addAttack( attack2 );
    //char2->addAttack( attack2 );
  
  
  m_pMapChar[  7 + 7 * m_pEngine->getMapWidth() ] = char1;
  m_pMapChar[  7 + 18 * m_pEngine->getMapWidth() ] = char2;
  addChar( char1 );
  addChar( char2 );
}

//-----------------------------------------------------------------------------
/*
	main gameloop
*/
bool CGame::idle()
{
    // as longs as no esc is pressed // just for development time
    while( m_pSDLFrame->handleEvents() )
    {
        if( !m_pEngine->idle( m_dwFrameTime ))
            return 0;

    // draw entities
    drawEntities();

    m_pMenu->draw( m_pSDLFrame );
 //     m_pEffect1->draw( m_pSDLFrame );
  //    m_pEffect2->draw( m_pSDLFrame );

    
    if( m_pSDLFrame->keyPressed( SDLK_b ) )
    {
       m_pEngine->setKeyboardScroll( !m_pEngine->getKeyboardScroll() );
       m_bEditMode = !m_bEditMode;
    }

    if( m_bEditMode )
    {
        // editor
        m_pEngine->setKeyboardScroll( false );
        m_pEdit->idle();
    }
    else
    {
        // ingame
        if( m_pSDLFrame->getMouseState() == SDL_BUTTON_LEFT )
        {
            pickEntity();
        }
       if( m_pSDLFrame->getMouseState() == SDL_BUTTON_RIGHT )
        {
//            unselectEntities();
        }
    }

    // print out name and version ;)
    m_pFont->putString( "nameless little baby :)", 10, 10 );
     m_pFont->setColor( 0x000000 );
    // print out fps
    std::ostringstream o;
    o << "fps " << static_cast<float>( 1000 / static_cast<float>( m_dwFrameTime ) );
    m_pFont->putString( o.str().c_str(), 10, 25 );
    
    // flip the backbuffer
    m_pSDLFrame->flip();

    // calculate things ;)
 // m_pEffect1->move( m_dwFrameTime );
 // m_pEffect2->move( m_dwFrameTime );
  
    Char *tmp = m_pCharlist;
    while( tmp->getNext() != NULL )
    {
        tmp = tmp->getNext();
        tmp->idle( m_dwFrameTime );
        // give the menu our current selected char
        if( tmp->isSelected() )
          m_pMenu->idle( tmp );
    }
  std::cout << char2->getNumberAttacks() << "\n";
    // calculate our FrameTime
    unsigned long dwCurrentTime = SDL_GetTicks();
    m_dwFrameTime  = dwCurrentTime - m_dwFrameStart;
    m_dwFrameStart = dwCurrentTime;


    }
return true;
}

//-----------------------------------------------------------------------------
void CGame::drawEntities()
{
    // reset the isDrawn flag of the entities
    enableEntityDraw();

    for( int y = 0; y < m_pEngine->getMapWidth(); ++y )
        for( int x = 0; x < m_pEngine->getMapHeight(); ++x )
        {
            if( m_pMapEntity[ x + y * m_pEngine->getMapWidth() ] != NULL )
            {
                CEntity *tmp = m_pMapEntity[ x + y * m_pEngine->getMapWidth() ];
                if( !tmp->isDrawn() )
                {
                    // define destination rect
                    SDL_Rect dstRect;
                    dstRect.x = (int)(( ( x - y ) * (m_pEngine->getTileWidth() / 2) ) + m_pEngine->getHalfMapWidth() - m_pEngine->getOffsetX());
                    dstRect.y = (int)(( ( x + y ) * (m_pEngine->getTileHeight() / 2) ) - m_pEngine->getOffsetY());

                    SDL_Rect srcRect = tmp->getSize();

                    // modify fX cause of bigger than 1 tile sized entities
                    dstRect.x -= (  m_pMapEntity[ x + y * m_pEngine->getMapWidth() ]->getSize().w / 2 - m_pEngine->getTileWidth() / 2 );
                    // modify fY cause of bigger than 1 tile sized entities
                    dstRect.y -= ( tmp->getSize().h  - ( tmp->getTileSize() * m_pEngine->getTileHeight() ) );

                    if( m_pEngine->clip( m_pEngine->getViewPort(), srcRect, dstRect ) )
                    {
                        tmp->draw( m_pSDLFrame, dstRect.x, dstRect.y );
                    }
                    tmp->setDrawn( true );
                }
            }
        if( m_pMapChar[ x + y * m_pEngine->getMapWidth() ] != NULL )
        {
          Char *tmp = m_pMapChar[ x + y * m_pEngine->getMapWidth() ];
          // define destination rect
          SDL_Rect dstRect;
          dstRect.x = (int)(( ( x - y ) * (m_pEngine->getTileWidth() / 2) ) + m_pEngine->getHalfMapWidth() - m_pEngine->getOffsetX());
          dstRect.y = (int)(( ( x + y ) * (m_pEngine->getTileHeight() / 2) ) - m_pEngine->getOffsetY());

          SDL_Rect srcRect = tmp->getSize();

          dstRect.y -= ( tmp->getSize().h  - m_pEngine->getTileHeight() );

          //check if entity is visible
          if( m_pEngine->clip( m_pEngine->getViewPort(), srcRect, dstRect ) )
          {
            tmp->draw( m_pSDLFrame, dstRect.x, dstRect.y );
           // tmp->drawSelection( m_pSDLFrame, dstRect.x, dstRect.y );
          }
        }
      }
        

    // search for selected char
    for( int y = 0; y < m_pEngine->getMapWidth(); ++y )
        for( int x = 0; x < m_pEngine->getMapHeight(); ++x )
            if( m_pMapChar[ x + y * m_pEngine->getMapWidth() ] != NULL )
            {
                Char *tmp = m_pMapChar[ x + y * m_pEngine->getMapWidth() ];
                if( tmp->isSelected() )
                {
                    SDL_Rect dstRect;
                    dstRect.x = (int)(( ( x - y ) * (m_pEngine->getTileWidth() / 2 ) ) + m_pEngine->getHalfMapWidth() - m_pEngine->getOffsetX());
                    dstRect.y = (int)(( ( x + y ) * (m_pEngine->getTileHeight() / 2 ) ) - m_pEngine->getOffsetY());

                    SDL_Rect srcRect = tmp->getSize();

                    dstRect.y -= ( tmp->getSize().h  - m_pEngine->getTileHeight() );

                    if( m_pEngine->clip( m_pEngine->getViewPort(), srcRect, dstRect ) )
                           tmp->drawSelection( m_pSDLFrame, dstRect.x, dstRect.y );
                }
            }
}

//-----------------------------------------------------------------------------
/*
        check if and what char is below the mouseclick
*/
bool CGame::pickEntity()
{
    int iMouseX = m_pSDLFrame->getMouseX();
    int iMouseY = m_pSDLFrame->getMouseY();

    for( int x = m_pEngine->getMapWidth() - 1; x >= 0; --x )
        for( int y = m_pEngine->getMapHeight() - 1; y >= 0; --y )
            if( m_pMapChar[ x + y * m_pEngine->getMapWidth() ] != NULL )
            {
                Char *tmp = m_pMapChar[ x + y * m_pEngine->getMapWidth() ];
                
                SDL_Rect dstRect;
                dstRect.x = (int)(( ( x - y ) * (m_pEngine->getTileWidth() / 2) ) + m_pEngine->getHalfMapWidth() - m_pEngine->getOffsetX());
                dstRect.y = (int)(( ( x + y ) * (m_pEngine->getTileHeight() / 2) ) - m_pEngine->getOffsetY());

                SDL_Rect srcRect = tmp->getSize();

                dstRect.y -= ( tmp->getSize().h - m_pEngine->getTileHeight());

                // check if the mousepos is in the rect of the entity
                if( iMouseX > dstRect.x && iMouseX < dstRect.x + srcRect.w
                && iMouseY > dstRect.y && iMouseY < dstRect.y + srcRect.h )
                {
                    // first unselect all chars
                    unselectChars();
                    // and then select the one that is beneath the cursor
                    tmp->setSelected( true );
                    return true;
                }
            }
}

//-----------------------------------------------------------------------------
/*
        load m_pPrototypes out of a file and put them in a m_pPrototype array
*/
void CGame::loadPrototypes( string file )
{
    int actPrototypes = 0;
    // read in the entities
    ifstream ifs;
    // open filestream
    ifs.open( file.c_str(), ios::in );

    string read;

    // read until eof                                                                                                                                                                
    while ( ifs )
    {
        // read
        ifs >> read;
        
        // read in number
        if( read == "(number)" )
        {
            ifs >> m_iPrototypeNumber;
            // initialze the m_pPrototype array
            m_pPrototype = new CEntity*[ m_iPrototypeNumber ];
        }
        // e.g. (environment) gfx/entities/tree.png 60 110
        else if ( read == "(environment)" )
        {
            ifs >> read;
            SDL_Surface *tmp = m_pSDLFrame->loadImage( read );
            
            int w, h, ID, tileSize;
            ifs >> ID;
            ifs >> w;
            ifs >> h;
            ifs >> tileSize;
            cout << "loading environment\n";                        
            m_pPrototype[ actPrototypes ] = new CEnvironment( tmp, ID, w, h, tileSize );
            ++actPrototypes;
        }
        // e.g. (tower) gfx/entities/tower.png 60 200
        else if( read == "(tower)" )
        {
            ifs >> read;
            SDL_Surface *tmp = m_pSDLFrame->loadImage( read );
            int w, h, ID, tileSize;
            ifs >> ID;
            ifs >> w;
            ifs >> h;
            ifs >> tileSize;
            cout << "loading tower\n";
            m_pPrototype[ actPrototypes ] = new CTower( tmp, ID, w, h, tileSize, 100 );
            ++actPrototypes;
        }
        // reset readstring
        read = "";
    }
    // close the filestream
    ifs.close();
}

void CGame::addEntity( CEntity *entity )
{
    CEntity *tmp = m_pEntitylist;

    while( tmp->m_pNext != NULL )
        tmp = tmp->m_pNext;

    tmp->m_pNext = entity;
    tmp->m_pNext->m_pPrev = tmp;
    ++m_iActEntities;
}

void CGame::addChar( Char *c )
{
    Char *tmp = m_pCharlist;

    while( tmp->getNext() != NULL )
        tmp = tmp->getNext();

    tmp->setNext( c );
    c->setPrev( tmp );
    ++m_iActChars;
}

//-----------------------------------------------------------------------------
void CGame::deleteEntity( CEntity *entity )
{
        entity->m_pNext->m_pPrev = entity->m_pPrev;
        entity->m_pPrev->m_pNext = entity->m_pNext;
        --m_iActEntities;
        delete entity;
}

//-----------------------------------------------------------------------------
void CGame::deleteChar( Char *c )
{
        c->getNext()->setPrev( c->getPrev() );
        c->getPrev()->setNext( c->getNext() );
        --m_iActChars;
        delete c;
}


//-----------------------------------------------------------------------------
void CGame::unselectChars()
{
    Char *tmp = m_pCharlist;
    while( tmp->getNext() != NULL )
    {
        tmp = tmp->getNext();
        tmp->setSelected( false );
    }
}

//-----------------------------------------------------------------------------
void CGame::enableEntityDraw()
{
    CEntity *tmp = m_pEntitylist;
    while( tmp->m_pNext != NULL )
    {
        tmp = tmp->m_pNext;
        tmp->setDrawn( false );
    }
}
