//-----------------------------------------------------------------------------
/*
    CSimpleFont.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/

#include "CSimpleFont.h"

//-----------------------------------------------------------------------------
CSimpleFont::CSimpleFont()
{
    m_pFont = NULL;
    m_iCharWidth = 0;
}

//-----------------------------------------------------------------------------
CSimpleFont::~CSimpleFont()
{
    SDL_FreeSurface( m_pFont );
}

//-----------------------------------------------------------------------------
void CSimpleFont::init( std::string fontfile, CSDL* sdlFrame )
{
    m_pSDLFrame = sdlFrame;
    m_pFont = sdlFrame->loadImage( fontfile );
    m_iCharWidth = static_cast<int>( m_pFont->w / 46 );
}

//-----------------------------------------------------------------------------
void CSimpleFont::setColor( Uint32 color )
{
   
}

//-----------------------------------------------------------------------------
void CSimpleFont::putString( std::string text, int x, int y )
{
    for( int i = 0; i < text.length(); ++i )
        putChar( text.c_str()[ i ], x + ( m_iCharWidth + ( m_iCharWidth / 5 ) ) * i, y );
}

//-----------------------------------------------------------------------------
void CSimpleFont::putChar( char c, int x, int y )
{
    // srcRect
    SDL_Rect srcRect = { 0, 0, m_iCharWidth, m_iCharWidth };

    // which char is it :) ?  ( set the srcRect)
    switch( c )
    {
        case ' ':
            break;

        case '0':
            srcRect.x = 1 * m_iCharWidth;
            break;

        case '1':
            srcRect.x = 2 * m_iCharWidth;
            break;

        case '2':
            srcRect.x = 3 * m_iCharWidth;
            break;

        case '3':
            srcRect.x = 4 * m_iCharWidth;
            break;

        case '4':
            srcRect.x = 5 * m_iCharWidth;
            break;

        case '5':
            srcRect.x = 6 * m_iCharWidth;
            break;

        case '6':
            srcRect.x = 7 * m_iCharWidth;
            break;

        case '7':
            srcRect.x = 8 * m_iCharWidth;
            break;

        case '8':
            srcRect.x = 9 * m_iCharWidth;
            break;

        case '9':
            srcRect.x = 10 * m_iCharWidth;
            break;

        case '.':
            srcRect.x = 11 * m_iCharWidth;
            break;

        case 'A':
        case 'a':        
            srcRect.x = 12 * m_iCharWidth;
            break;

        case 'B':
        case 'b':
            srcRect.x = 13 * m_iCharWidth;
            break;

        case 'C':
        case 'c':
            srcRect.x = 14 * m_iCharWidth;
            break;

        case 'D':
        case 'd':
            srcRect.x = 15 * m_iCharWidth;
            break;

        case 'E':
        case 'e':
            srcRect.x = 16 * m_iCharWidth;
            break;

        case 'F':
        case 'f':
            srcRect.x = 17 * m_iCharWidth;
            break;

        case 'G':
        case 'g':
            srcRect.x = 18 * m_iCharWidth;
            break;

        case 'H':
        case 'h':
            srcRect.x = 19 * m_iCharWidth;
            break;

        case 'I':
        case 'i':
            srcRect.x = 20 * m_iCharWidth;
            break;            

        case 'J':
        case 'j':
            srcRect.x = 21 * m_iCharWidth;
            break;

        case 'K':
        case 'k':
            srcRect.x = 22 * m_iCharWidth;
            break;

        case 'L':
        case 'l':
            srcRect.x = 23 * m_iCharWidth;
            break;

        case 'M':
        case 'm':
            srcRect.x = 24 * m_iCharWidth;
            break;

        case 'N':
        case 'n':
            srcRect.x = 25 * m_iCharWidth;
            break;

        case 'O':
        case 'o':
            srcRect.x = 26 * m_iCharWidth;
            break;

        case 'P':
        case 'p':
            srcRect.x = 27 * m_iCharWidth;
            break;

        case 'Q':
        case 'q':
            srcRect.x = 28 * m_iCharWidth;
            break;

        case 'R':
        case 'r':
            srcRect.x = 29 * m_iCharWidth;
            break;

        case 'S':
        case 's':
            srcRect.x = 30 * m_iCharWidth;
            break;

        case 'T':
        case 't':
            srcRect.x = 31 * m_iCharWidth;
            break;

        case 'U':
        case 'u':
            srcRect.x = 32 * m_iCharWidth;
            break;

        case 'V':
        case 'v':
            srcRect.x = 33 * m_iCharWidth;
            break;

        case 'W':
        case 'w':
            srcRect.x = 34 * m_iCharWidth;
            break;
            
        case 'X':
        case 'x':
            srcRect.x = 35 * m_iCharWidth;
            break;

        case 'Y':
        case 'y':
            srcRect.x = 36 * m_iCharWidth;
            break;

        case 'Z':
        case 'z':
            srcRect.x = 37 * m_iCharWidth;
            break;

        case '!':
            srcRect.x = 38 * m_iCharWidth;
            break;

        case '"':
            srcRect.x = 39 * m_iCharWidth;
            break;

        case ',':
            srcRect.x = 40 * m_iCharWidth;
            break;

        case '[':
            srcRect.x = 41 * m_iCharWidth;
            break;

        case ']':
            srcRect.x = 42 * m_iCharWidth;
            break;

        case '(':
            srcRect.x = 43 * m_iCharWidth;
            break;

        case ')':
            srcRect.x = 44 * m_iCharWidth;
            break;

        case ':':
            srcRect.x = 45   * m_iCharWidth;
            break;
            
        default:
            break;
    }

    // set the destRect
    SDL_Rect dstRect = { x, y, 0, 0 };

    // blit the char
    m_pSDLFrame->blitSurface( m_pFont, srcRect, dstRect );    
}
