/*
    char.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/

#include "char.h"

Char::Char()
{
  m_pPrev = m_pNext = NULL;
  m_pAttacks = new Attack();
  m_bSelected = false;
  m_sName = "nameless";
  m_iEssence = 0;
  m_iEnergy = 0;
  m_iNumberAttacks = 0;
}

Char::~Char()
{
  SDL_FreeSurface( m_pSprites );
  delete m_pAttacks;
}

void Char::setPrev( Char *prev )
{
  m_pPrev = prev;
}

void Char::setNext( Char *next )
{
  m_pNext = next;
}

SDL_Rect Char::getSize()
{
  SDL_Rect tmp = { 0, 0, m_iWidth, m_iHeight };
  return tmp;
}

void Char::setSelected( bool b )
{
  m_bSelected = b;
}

void Char::setName( std::string name )
{
  m_sName = name;
}

void Char::setEssence( int essence )
{
  m_iEssence = essence;
}

void Char::setEnergy( int energy )
{
  m_iEnergy = energy;
}

void Char::addAttack( Attack *attack )
{
  Attack *tmp = m_pAttacks;
  while( tmp->getNext() != NULL )
    tmp = tmp->getNext();
  tmp->setNext( attack );
  attack->setPrev( tmp );
  ++m_iNumberAttacks;      
}

