/*
    char.h - Author: Marcus Krner - 2003 - This source is GPL
    abstract char class
*/

#ifndef CHAR_H                                              
#define CHAR_H

#include <SDL/SDL.h>
#include <string>
#include "../CSDL.h"
#include "../globals.h"
#include "../attacks/attack.h"

class Char
{
public:
  Char();
  virtual ~Char();
  virtual void draw( CSDL *sdlFrame, int x, int y ){};
  virtual void drawSelection( CSDL *sdlFrame, int x, int y ){};
  virtual void idle( unsigned long frameTime ){};
  SDL_Rect getSize();  
  Char *getPrev(){ return m_pPrev; };
  Char *getNext(){ return m_pNext; };
  bool isSelected(){ return m_bSelected; };
  void setSelected( bool b );
  void setPrev( Char *prev );
  void setNext( Char *next );
  
  // character skills, name, etc. ( maybe push in an other class? )
  std::string getName(){ return m_sName; };
  int getEssence(){ return m_iEssence; };
  int getEnergy(){ return m_iEnergy; };
  int getNumberAttacks(){ return m_iNumberAttacks; };
  void setName( std::string name );
  void setEssence( int essence );
  void setEnergy( int energy );
  void addAttack( Attack *attack );
  Attack *getAttacks(){ return m_pAttacks; };
  
private:
  Char *m_pPrev, *m_pNext;
    
protected:
  SDL_Surface* m_pSprites;
  bool m_bSelected;
  float m_fX, m_fY;
  float m_fSpeed;
  float m_fAnimSpeed, m_fFrame;
  int m_iWidth, m_iHeight;
  direction m_dDirection;
  int m_iNumberAttacks;
  Attack *m_pAttacks;

  std::string m_sName;
  int m_iEssence;
  int m_iEnergy;
};

#endif
