/*
    simplechar.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/

#include "simplechar.h"

SimpleChar::SimpleChar( CSDL *sdlFrame, std::string spritefile, int width, int height, float x, float y, float speed, float animspeed )
{
  m_pSprites = sdlFrame->loadImage( spritefile );
  m_iWidth = width;
  m_iHeight = height;
  m_fX = x;
  m_fY = y;
  m_fSpeed = speed;
  m_fAnimSpeed = animspeed;
  m_fFrame = 0.0f;
  m_dDirection = northeast;
}

SimpleChar::~SimpleChar()
{
}

void SimpleChar::draw( CSDL *sdlFrame, int x, int y )
{
  SDL_Rect srcRect = { 0, 0, m_iWidth, m_iHeight };

  srcRect.y = static_cast<int>( m_fFrame ) * m_iHeight;
  
  switch( m_dDirection )
  {
    case northeast:
      srcRect.x = 0 * m_iWidth;
      break;

    case southeast:
      srcRect.x = 1 * m_iWidth;
      break;

    case southwest:
      srcRect.x = 2 * m_iWidth;
      break;

    case northwest:
      srcRect.x = 3 * m_iWidth;
      break;

    default:
      srcRect.x = 0 * m_iWidth;
      break;    
  }

  SDL_Rect  dstRect = { x, y, 0, 0 };
              
  sdlFrame->blitSurface( m_pSprites, srcRect, dstRect );
  
}

void SimpleChar::idle( unsigned long frameTime )
{
  m_fFrame += m_fAnimSpeed * 1000.0f/frameTime;
  if( m_fFrame > 4.0f )
    m_fFrame = 0.0f;
}


void SimpleChar::drawSelection( CSDL *sdlFrame, int x, int y )
{

      // draw selection
    for( int i = 0; i < 5; ++i )
    {
        // top left
        sdlFrame->setPixel( x + i, y, 0x06ff00 );
        sdlFrame->setPixel( x,  y + i, 0x06ff00 );
        // top right
        sdlFrame->setPixel( x + m_iWidth - 1 - i, y, 0x06ff00 );
        sdlFrame->setPixel( x + m_iWidth - 1 , y + i, 0x06ff00 );
        // lower left
        sdlFrame->setPixel( x + i, y + m_iHeight - 1, 0x06ff00 );
        sdlFrame->setPixel( x, y + m_iHeight - 1 - i, 0x06ff00 );
        // lower right
        sdlFrame->setPixel( x + m_iWidth - 1 - i, y + m_iHeight - 1, 0x06ff00 );
        sdlFrame->setPixel( x + m_iWidth - 1, y + m_iHeight - 1 - i, 0x06ff00 );
    }
    // draw energy
   /* for( int i = 0; i < m_iWidth - 1; ++ i )
    {
        sdlFrame->setPixel( x + i, y - 3, 0x06ff00 );
        sdlFrame->setPixel( x + i, y - 6, 0x06ff00 );
    }
    for( int i = 0; i < 4; ++ i )
    {
        sdlFrame->setPixel( x, y - 3 - i, 0x06ff00 );
        sdlFrame->setPixel( x + m_iWidth - 1, y - 3 - i, 0x06ff00 );
    }
    for( int i = 1; i < m_iWidth -1; ++i )
    {
        sdlFrame->setPixel( x + i, y - 4, 0x00ff00 );
        sdlFrame->setPixel( x + i, y - 5, 0xff0000 );
    }*/
}
