//-----------------------------------------------------------------------------
/*
    CEntity.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/

#include "CEntity.h"

//-----------------------------------------------------------------------------
CEntity::CEntity()
{
    m_bSelected = false;
    m_iTilesPassed = 0;
    m_pNext = NULL;
    m_pPrev = NULL;
}

//-----------------------------------------------------------------------------
CEntity::~CEntity()
{
// NOTE_ HAVE TO BE REDONE VIA REFERENCECOUNTING OR SOMEHOW ( MEMORYLEAK )
//    SDL_FreeSurface( m_pSprite );
}

//-----------------------------------------------------------------------------
/*
    have to be overwritten by extended classes
*/
void CEntity::idle( unsigned long dwFrameTime )
{
}

//-----------------------------------------------------------------------------
void CEntity::setSelected( bool b )
{
    m_bSelected = b;
}

//-----------------------------------------------------------------------------
void CEntity::setDrawn( bool b )
{
    m_bDrawn = b;
}

//-----------------------------------------------------------------------------
bool CEntity::tilesPassed()
{
    // check if this is the tile the entity is last at
    if( m_iTilesPassed < ( m_iTileSize * m_iTileSize ) - 1 )
    {
        ++m_iTilesPassed;
        return false;
    }
    else
    {
        m_iTilesPassed = 0;
        return true;
    }
}
