//-----------------------------------------------------------------------------
/*
    CEntity.h - Author: Marcus Krner - 2003 - This source is GPL
    abstract class for map entitys
*/

#ifndef CENTITY_H_
#define CENTITY_H_

#include <string>
#include <SDL/SDL.h>

#include "../CSDL.h"

using namespace std;

//-----------------------------------------------------------------------------
/*
    class CEntity
*/
class CEntity
{
protected:

    SDL_Surface* m_pSprite;
    SDL_Rect m_Size;

    int m_iID;
    int m_iTileSize;
    int m_iTilesPassed;

    bool m_bSelected;
    bool m_bDrawn;

public:

    CEntity *m_pNext, *m_pPrev;    

    CEntity();
    virtual ~CEntity();

    SDL_Surface *getSprite(){ return m_pSprite; };

    SDL_Rect getSize(){ return m_Size; };

    virtual CEntity* clone(){};
    
    void idle( unsigned long dwFrameTime );
    
    virtual void draw( CSDL* sdlFrame, int x, int y ){};
    virtual void drawSelection( CSDL* sdlFrame, int x, int y ){};
    
    void setSelected( bool b );
    void setDrawn( bool b );
    
    bool isSelected(){ return m_bSelected; };
    bool isDrawn(){ return m_bDrawn; };
    bool tilesPassed();
    
    
    int getID(){ return m_iID; };
    int getTileSize(){ return m_iTileSize; };
};

#endif
