//-----------------------------------------------------------------------------
/*
    CEnvironment.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/
#include "CEnvironment.h"

//-----------------------------------------------------------------------------
CEnvironment::CEnvironment( SDL_Surface *sprite, int ID, int width, int height, int tileSize )
{
    m_pSprite = sprite;
    m_iID = ID;
    m_Size.w = width;
    m_Size.h = height;
    m_iTileSize = tileSize;
}

//-----------------------------------------------------------------------------
CEnvironment::~CEnvironment()
{
}
 
//-----------------------------------------------------------------------------
void CEnvironment::draw( CSDL *sdlFrame, int x, int y )
{
    sdlFrame->blitSurface( m_pSprite, x, y );
}

//-----------------------------------------------------------------------------
void CEnvironment::drawSelection( CSDL *sdlFrame, int x, int y )
{
    // draw selection
    for( int i = 0; i < 5; ++i )
    {
        // top left
        sdlFrame->setPixel( x + i, y, 0x06ff00 );
        sdlFrame->setPixel( x,  y + i, 0x06ff00 );
        // top right
        sdlFrame->setPixel( x + m_Size.w - 1 - i, y, 0x06ff00 );
        sdlFrame->setPixel( x + m_Size.w - 1 , y + i, 0x06ff00 );
        // lower left
        sdlFrame->setPixel( x + i, y + m_Size.h - 1, 0x06ff00 );
        sdlFrame->setPixel( x, y + m_Size.h - 1 - i, 0x06ff00 );
        // lower right
        sdlFrame->setPixel( x + m_Size.w - 1 - i, y + m_Size.h - 1, 0x06ff00 );
        sdlFrame->setPixel( x + m_Size.w - 1, y + m_Size.h - 1 - i, 0x06ff00 );
    }
}
