//-----------------------------------------------------------------------------
/*
    CTower.cpp - Author: Marcus Krner - 2003 - This source is GPL
    class CTower
*/
#include "CTower.h"

//-----------------------------------------------------------------------------
CTower::CTower( SDL_Surface *sprite, int ID, int width, int height, int tileSize, int health ) : CEntity()
{
    m_pSprite = sprite;
    m_iID = ID;
    m_Size.w = width;
    m_Size.h = height;
    m_iTileSize = tileSize;
    m_iHealth = health;
}

//-----------------------------------------------------------------------------
CTower::~CTower()
{
}
 
//-----------------------------------------------------------------------------
void CTower::draw( CSDL *sdlFrame, int x, int y )
{
    sdlFrame->blitSurface( m_pSprite, x, y );
}

//-----------------------------------------------------------------------------
void CTower::drawSelection( CSDL* sdlFrame, int x, int y )
{
    // draw selection
    for( int i = 0; i < 5; ++i )
    {
        // top left
        sdlFrame->setPixel( x + i, y, 0x06ff00 );
        sdlFrame->setPixel( x,  y + i, 0x06ff00 );
        // top right
        sdlFrame->setPixel( x + m_Size.w - 1 - i, y, 0x06ff00 );
        sdlFrame->setPixel( x + m_Size.w - 1 , y + i, 0x06ff00 );
        // lower left
        sdlFrame->setPixel( x + i, y + m_Size.h - 1, 0x06ff00 );
        sdlFrame->setPixel( x, y + m_Size.h - 1 - i, 0x06ff00 );
        // lower right
        sdlFrame->setPixel( x + m_Size.w - 1 - i, y + m_Size.h - 1, 0x06ff00 );
        sdlFrame->setPixel( x + m_Size.w - 1, y + m_Size.h - 1 - i, 0x06ff00 );
    }
    // draw energy
    for( int i = 0; i < m_Size.w - 1; ++ i )
    {
        sdlFrame->setPixel( x + i, y - 3, 0x06ff00 );
        sdlFrame->setPixel( x + i, y - 6, 0x06ff00 );
    }
    for( int i = 0; i < 4; ++ i )
    {
        sdlFrame->setPixel( x, y - 3 - i, 0x06ff00 );
        sdlFrame->setPixel( x + m_Size.w - 1, y - 3 - i, 0x06ff00 );
    }
    for( int i = 1; i < m_Size.w -1; ++i )
    {
        sdlFrame->setPixel( x + i, y - 4, 0xff5400 );
        sdlFrame->setPixel( x + i, y - 5, 0xff5400 );
    }    
}
