//-----------------------------------------------------------------------------
/*
    main.cpp - Author: Marcus Krner - 2003 - This source is GPL
    main for the isometric game
*/

#include "CIsoEngine.h"
#include "CSDL.h"
#include "CLog.h"
#include "CGame.h"

using namespace std;

//-----------------------------------------------------------------------------
/*
    main, have i more to say :) ?
*/
int main( int argc, char** argv )
{
    // create logging object
    CLog *log = new CLog( "system/log.txt" );

    log->write( "| Starting logfile _ gemetzelbla project" );

    // create our SDL Frame
    CSDL *sdlFrame = new CSDL();
    // init the SDL Frame
    sdlFrame->init( log );
    // set up our SDL Frame
    sdlFrame->setFrame( "system/init.cfg" );

    // Now let's create the CIsoEngine instance
    CIsoEngine *engine = new CIsoEngine();
    if( !engine->init(  sdlFrame, log, "system/init.cfg" ) )
        return 0;


    // And finally the Game instance
    CGame *game = new CGame();
    game->init( sdlFrame, engine, log );

    // call gameloop
    game->idle();

    // delete our memory
    delete game;
    delete engine;

     // first shut down sdl
    sdlFrame->shutdown();
     // and then delete the sdlFrame
    delete sdlFrame;

    delete log;

    // finishing line ;)
    return 0;
}
