/*
    imageparticle.cpp - Author: Marcus Krner - 2003 - This source is GPL
*/

#include "imageparticle.h"
                              
ImageParticle::ImageParticle( SDL_Surface *image, float x, float y, float speedx, float speedy, int lifeTime )
{
  m_pImage = image;
  m_fX = x;
  m_fY = y;
  m_fSpeedX = speedx;
  m_fSpeedY = speedy;
  m_pPrev = m_pNext = NULL;
  m_iLifeTime = lifeTime;
  m_dwStartTime = SDL_GetTicks();
}

ImageParticle::ImageParticle()
{
  m_pPrev = m_pNext = NULL;
}

ImageParticle::~ImageParticle()
{
}

void ImageParticle::draw( CSDL *sdlFrame )
{
  sdlFrame->blitSurface( m_pImage, m_fX  - m_pImage->w / 2.0f, m_fY  - m_pImage->h / 2.0f );
}

bool ImageParticle::move( unsigned long frameTime )
{
  if( SDL_GetTicks() < m_dwStartTime + static_cast<unsigned long>( m_iLifeTime ) )
  {
    m_fX += m_fSpeedX * static_cast<float>( frameTime ) / 1000.0f;
    m_fY += m_fSpeedY * static_cast<float>( frameTime ) / 1000.0f;
    return true;
  }
  return false;
}

void ImageParticle::setPrev( ImageParticle *prev )
{
  m_pPrev = prev;
}

void ImageParticle::setNext( ImageParticle *next )
{
  m_pNext = next;
}


           