/*
    imageparticle.cpp - Author: Marcus Krner - 2003 - This source is GPL
    imageparticle
*/

#ifndef IMAGEPARTICLE_H
#define IMAGEPARTICLE_H

#include <SDL/SDL.h>
#include <math.h>
#include "../CSDL.h"

class ImageParticle
{
public: 
  ImageParticle( SDL_Surface *image, float x, float y, float speedx, float speedy, int lifeTime );
  ImageParticle();
  ~ImageParticle();
  void draw( CSDL *sdlFrame );
  bool move( unsigned long frameTime );
  void setPrev( ImageParticle *prev );
  void setNext( ImageParticle *next );
  ImageParticle *getPrev() { return m_pPrev; };
  ImageParticle *getNext() { return m_pNext; };
private:
  float m_fX, m_fY;
  float m_fSpeedX, m_fSpeedY;
  unsigned long m_dwStartTime;
  int m_iLifeTime;
  ImageParticle *m_pPrev, *m_pNext;
  SDL_Surface *m_pImage;
};

#endif
