/*
    particeleffect.h - Author: Marcus Krner - 2003 - This source is GPL
    particeleffect
*/

#ifndef IMAGEPARTICLEEFFECT_H
#define IMAGEPARTICLEEFFECT_H

#include <cstdlib> // srand() rand()%100
#include <math.h>
#include <SDL/SDL.h>
#include "imageparticle.h"
#include "../CSDL.h"

class ImageParticleEffect
{
public:
  ImageParticleEffect( SDL_Surface *image, float x, float y, double angle, float speed, float particleangle, float particlespeed, int width, int maxParticles, int particleLifeTime );
  ~ImageParticleEffect();
  void draw( CSDL *sdlFrame );
  void move( unsigned long frameTime );
private:
  void addParticle();
  void delParticle( ImageParticle *p );
  int m_iMaxParticles, m_iActParticles;
  int m_iParticleLifeTime, m_iWidth;
  float m_fX, m_fY;
  float m_fAngle, m_fParticleAngle;
  float m_fSpeed, m_fParticleSpeed;
  ImageParticle *m_pParticles;
  SDL_Surface *m_pImage;
};

#endif
