/*
    particle.h - Author: Marcus Krner - 2003 - This source is GPL
*/

#include "particle.h"

Particle::Particle()
{
  m_pPrev = m_pNext = NULL;
}

Particle::Particle( Uint32 color, float x, float y, float speedx, float speedy, int lifeTime )
{
  m_uiColor = color;
  m_fX = x;
  m_fY = y;
  m_fSpeedX = speedx;
  m_fSpeedY = speedy;
  m_pPrev = m_pNext = NULL;
  m_iLifeTime = lifeTime;
  m_dwStartTime = SDL_GetTicks();
}

Particle::~Particle()
{
}

void Particle::draw( CSDL *sdlFrame )
{
  sdlFrame->setPixel( static_cast<int>( m_fX ), static_cast<int>( m_fY ), m_uiColor );
}

bool Particle::move( unsigned long frameTime )
{
  if( SDL_GetTicks() < m_dwStartTime + static_cast<unsigned long>( m_iLifeTime ) )
  {
    m_fX += m_fSpeedX * static_cast<float>( frameTime ) / 1000.0f;
    m_fY += m_fSpeedY * static_cast<float>( frameTime ) / 1000.0f;
    return true;
  }
  return false;
}

void Particle::setPrev( Particle *prev )
{
  m_pPrev = prev;
}

void Particle::setNext( Particle *next )
{
  m_pNext = next;
}
