/*
    particle.cpp - Author: Marcus Krner - 2003 - This source is GPL
    simple particel
*/

#ifndef PARTICLE_H
#define PARTICLE_H

#include <SDL/SDL.h>
#include "../CSDL.h"

class Particle
{
public: 
  Particle( Uint32 color, float x, float y, float speedx, float speedy, int lifeTime );
  Particle();
  ~Particle();
  void draw( CSDL *sdlFrame );
  bool move( unsigned long frameTime );
  void setPrev( Particle *prev );
  void setNext( Particle *next );
  Particle *getPrev() { return m_pPrev; };
  Particle *getNext() { return m_pNext; };
private:
  Uint32 m_uiColor;
  float m_fX, m_fY;
  float m_fSpeedX, m_fSpeedY;
  unsigned long m_dwStartTime;
  int m_iLifeTime;
  Particle *m_pPrev, *m_pNext;
};

#endif

