/*
    particeleffect.h - Author: Marcus Krner - 2003 - This source is GPL
    particeleffect
*/

#ifndef PARTICLEEFFECT_H
#define PARTICLEEFFECT_H

#include <cstdlib> // srand() rand()%100
#include <math.h>
#include <SDL/SDL.h>
#include "particle.h"
#include "../CSDL.h"

class ParticleEffect
{
public:
  ParticleEffect( Uint32 color, float x, float y, float angle, float speed, float particleangle, float particlespeed, int width, int maxParticles, int particleLifeTime );
  ~ParticleEffect();
  void draw( CSDL *sdlFrame );
  void move( unsigned long frameTime );
private:
  void addParticle();
  void delParticle( Particle *p );
  Uint32 m_uiColor;
  int m_iMaxParticles, m_iActParticles;
  int m_iParticleLifeTime, m_iWidth;
  float m_fX, m_fY;
  float m_fAngle, m_fParticleAngle;
  float m_fSpeed, m_fParticleSpeed;
  Particle *m_pParticles;
};

#endif
